#INCLUDE "dcdialog.CH"
#INCLUDE "dcowner.CH"

#define FONTBOLD      "Bold"    // change to "Fett" for German versions
#define FONTITALIC    "Italic"  // change to "Kursiv" for German versions
#define CRLF          Chr(13)+Chr(10)
#define GENDER_MALE   '..\..\icon\user_suit.png'
#define GENDER_FEMALE '..\..\icon\user_female.png'
#define GOOD_VALUE    '..\..\icon\smile_green.ico'
#define BAD_VALUE     '..\..\icon\smile_yellow.ico'

#pragma library("dclipx.lib")
#pragma library("dclip1.lib") // for DC_LoadRdds()

FUNCTION Main()

LOCAL GetList := {}, GetOptions := {}, oBrowse, nResDll, ;
   aPres := ;
         { { XBP_PP_COL_DA_ROWHEIGHT, 50 }, ;  // rows are 50 pixels high
           { XBP_PP_COL_DA_CELLHEIGHT, 50 } ,;
           { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY },;   // Hilite BG color
           { XBP_PP_COL_DA_CELLFRAMELAYOUT, XBPFRAME_BOX } ,;
           { XBP_PP_COL_DA_FRAMELAYOUT,     XBPFRAME_NONE} ,;
           { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_LINE },  /* Row Sep  */     ;
           { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_LINE } },  /* Col Sep  */     ;
   lOwnerDraw := .t.

DCGETOPTIONS AUTORESIZE

DC_LoadRdds()

nResDll := DllLoad('DCRES.DLL') /// load eXpress++ custom bitmaps
DC_BitmapResourceFile( { nResDll } )
DC_BitmapTransparentColor({192,192,192})

DC_BrowseColor( { nil, GRA_CLR_WHITE, nil, GraMakeRGBColor( {214,243,244} ) } )

USE customer VIA 'FOXCDX'

@ 0,0 DCBROWSE oBrowse ALIAS 'CUSTOMER' SIZE 96,25 PRESENTATION aPres FIT ;
      PREEVAL {|o|o:stdFontCompoundName := '10.Tahoma', ;
                  o:boldFontCompoundName := '10.Tahoma '+FONTBOLD, ;
                  o:boldItalicFontCompoundName := '12.Tahoma '+FONTBOLD+' '+FONTITALIC} ;
      TAGENABLE ;
      TAGCOLOR GRA_CLR_YELLOW, GRA_CLR_DARKGRAY ;
      TAGMODE DCGUI_TAGMODE_CLEAR

*      SUBCLASS 'DC_XbpOwnerDrawBrowseGeneric()' USEVISUALSTYLE NOHSCROLL ;

DCBROWSECOL DATA {||CellArray(1)} ;
                    HEADER 'ID' WIDTH 5 PARENT oBrowse ;
                    OWNERDRAW

*                    HEADER 'ID' WIDTH 5 PARENT oBrowse ;

DCBROWSECOL DATA {||CellArray(2)} ;
                    HEADER 'Name/Address'  WIDTH 25 PARENT oBrowse ;
                    COLOR {||{IF('Software'$CUSTOMER->bill_name,GraMakeRGBColor( { 253, 120, 41 } ),GRA_CLR_DARKGREEN),oBrowse:rowColor()[2]}} ;
                    OWNERDRAW ;
                    DRAG {|o| {select(), M->dcTags[select()][2]} } DIALOG {|mp1,mp2,oXbp| DragAuftrag(mp1,mp2,oXbp,select())}


DCBROWSECOL DATA {||CellArray(3)} ;
                    HEADER 'Contact'  WIDTH 15 PARENT oBrowse ;
                    COLOR {||{GRA_CLR_DARKRED,oBrowse:rowColor()[2]}} ;
                    OWNERDRAW ;
                    DROP {|o,a,mp1,mp2,nOffset| dc_arrayview(a) }

DCBROWSECOL DATA {||CellArray(4)} ;
                    HEADER 'Info/Rating' WIDTH 10 PARENT oBrowse ;
                    COLOR {||{GRA_CLR_DARKBLUE,GraMakeRGBColor({240,240,240})}} ;
                    OWNERDRAW

DCBROWSECOL DATA {||CellArray(5)} ;
                    HEADER 'Bitmap' ;
                    WIDTH 6 PARENT oBrowse ;
                    OWNERDRAW

DCBROWSECOL FIELD CUSTOMER->phone  HEADER 'Phone' WIDTH  10 PARENT oBrowse

@ 26,0 DCCHECKBOX lOwnerDraw PROMPT 'Use ownerdrawing' ;
       ACTION {||oBrowse:lOwnerDraw := lOwnerDraw,oBrowse:InvalidateRect()}

DCREAD GUI FIT TITLE 'Ownerdrawing sample' OPTIONS GetOptions

CLOSE ALL
RETURN nil

**************************************************************
STATIC FUNCTION DragAuftrag( mp1, mp2, oXbp, bereich )
LOCAL GetList[0], GetOptions, oDialog, aPos, cText1, nSelRec
Unused(mp2)

nSelRec:=len(M->dcTags[select()][2])
if nSelRec=0
   DC_PointerArrow(SetAppWindow())
   return NIL
elseif nSelRec=1
   cText1:=" "+alltrim(customer->bill_name)
else
   cText1:=" "+alltrim(str(nSelRec))+" Records"
endif

@ 2,0 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 4,0.8 ;

@ DCGUI_ROW, DCGUI_COL DCSAY cText1 ;
   COLOR GRA_CLR_BLACK, GRA_CLR_YELLOW ;
   FONT '10.Courier' SAYSIZE 0,1.1 ;
   OPTION XBPSTATIC_TEXT_LEFT + XBPSTATIC_TEXT_VCENTER

DCGETOPTIONS NOTITLEBAR ORIGIN XBPDLG_ORIGIN_MOUSE ;
   FITPAD 0 COLOR { 240, 240, 255 } ;
   BORDER XBPDLG_NO_BORDER ;
   HIDE ;
   NOTASKLIST

DCREAD GUI FIT OPTIONS GetOptions PARENT @oDialog EXIT NOAUTORESTORE

aPos := DC_CalcAbsolutePosition(mp1,oXbp)
aPos[2] -= (oDialog:currentSize()[2] + 30)
oDialog:setPos( aPos )
oDialog:show()
RETURN oDialog

* ----------

STATIC FUNCTION CellArray( nCol )

LOCAL aCell[0], i

/*
  [1] = <ocData>
  [2] = <nCol>
  [3] = <nRow>
  [4] = <nWidth>
  [5] = <nHeight>
  [6] = <font>
  [7] = <selectedFont>
  [8] = <fgColor>
 [ 9] = <bgColor>
 [10] = <nAlign>
*/

IF nCol == 1

  @ 5,5 DCADDCELLITEM CUSTOMER->cust_nmbr FONT '10.Tahoma Bold' SELFONT '12.Tahoma Bold Italic' TO aCell

ELSEIF nCol == 2

  @ 5,5 DCADDCELLITEM CUSTOMER->bill_name FONT '10.Tahoma Bold' SELFONT '12.Tahoma Bold Italic' TO aCell
  @ 18,5 DCADDCELLITEM CUSTOMER->bill_strt TO aCell
  @ 31,5 DCADDCELLITEM Trim(CUSTOMER->bill_city)+' '+ CUSTOMER->bill_zip TO aCell

ELSEIF nCol == 3

  @ 5, 5 DCADDCELLITEM CUSTOMER->contact FONT '10.Tahoma Bold' SELFONT '12.Tahoma Bold Italic' TO aCell
  @ 18, 5 DCADDCELLITEM CUSTOMER->email TO aCell
  @ 31, 5 DCADDCELLITEM IF(CUSTOMER->cont_gend=='m',GENDER_MALE,GENDER_FEMALE) WIDTH 15 HEIGHT 15 TO aCell

ELSEIF nCol == 4

  DCADDCELLITEM CustInfo(CUSTOMER->cust_val) FONT '10.Tahoma Bold' TO aCell

  IF CUSTOMER->cust_val == 0
    @ 35,5 DCADDCELLITEM BAD_VALUE WIDTH 10 HEIGHT 10 TO aCell
  ELSE
    FOR i := 1 TO CUSTOMER->cust_val
      @ 35, ((i-1)*12)+5 DCADDCELLITEM GOOD_VALUE WIDTH 10 HEIGHT 10 TO aCell
    NEXT
  ENDIF

ELSEIF nCol == 5

  @ 5, 5 DCADDCELLITEM 7300 + CUSTOMER->(RecNo()) WIDTH 35 HEIGHT 35 TO aCell

ENDIF

RETURN aCell

* ---------

STATIC FUNCTION CustInfo(nValue)
DO CASE
  CASE nValue == 0
  RETURN 'bad'
  CASE nValue == 1
  RETURN 'ok'
  CASE nValue == 2
  RETURN 'good'
  CASE nValue == 3
  RETURN 'very good'
  CASE nValue == 4
  RETURN 'excellent'
  CASE nValue == 5
  RETURN 'best ever'
ENDCASE
RETURN 'not known'

PROC appsys ; RETURN

